////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.MKB;

import java.util.*;

public class Condition implements java.io.Serializable{
  private Attribute myA1;
  private Attribute myA2;
  private String myExtent;

  public Condition(Attribute A1,Attribute A2,String Ext){
    myA1=A1;
    myA2=A2;
    myExtent=new String(Ext);
  }
  public String displayAll(){
    return new String(" "+myA1.getFullName()+myExtent+myA2.getFullName());
  }
  public boolean containsAtt(Attribute Att){
    return (myA1==Att||myA2==Att);
  }

  public Attribute getA1() {
    return myA1;
  }

  public Attribute getA2() {
    return myA2;
  }

  public String getExtent() {
    return myExtent;
  }
}

