////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.MKB;

import java.util.*;

public class JoinConstraint implements java.io.Serializable{
    private Relation myR1;
    private Relation myR2;
    private Vector myConditions=new Vector();
    private double joinSelectivity = 0.0;


  public JoinConstraint(Relation R1,Relation R2){
    myR1=R1;
    myR2=R2;
  }

  public boolean deleteJoinConstraint(){
    myR1.deleteJoinConstraint(this);
    myR2.deleteJoinConstraint(this);
    return true;
  }

  public boolean Empty(){
    return myConditions.size()==0;
  }


  public void displayAll(){
    String tempString=new String();
    for(int i=0;i<myConditions.size();i++)
      tempString=tempString+((Condition)myConditions.elementAt(i)).displayAll();

    System.out.println(myR1.getFullName()+" "+
		       myR2.getFullName()+" * "+
		       tempString);

  }

  public String toString() {
    String tempString=new String();
    for(int i=0;i<myConditions.size();i++)
      tempString=tempString+((Condition)myConditions.elementAt(i)).displayAll();
    return myR1.getFullName()+" "+myR2.getFullName()+" * "+tempString;
  }

  public boolean addCondition(Condition theCond){
    myConditions.addElement(theCond);
    return true;
  }

  public boolean addCondition(Attribute A1,Attribute A2,String Ext){
    myConditions.addElement(new Condition(A1,A2,Ext));
    return true;
  }

  public Relation getR1() {
    return myR1;
  }

  public Relation getR2() {
    return myR2;
  }

  public Vector getConditions() {
    return myConditions;
  }

    public void setJoinSelectivity(double js) {
        joinSelectivity = js;
    }

    public double getJoinSelectivity() {
        return joinSelectivity;
    }


}

