//
// Generated by JTB 1.2
//

package DSRG.MKB.visitor;
import DSRG.MKB.syntaxtree.*;
import java.util.*;

/**
 * All Object visitors must implement this interface.
 */
public interface ObjectVisitor {
   //
   // Object Auto class visitors
   //
   public Object visit(NodeList n, Object argu);
   public Object visit(NodeListOptional n, Object argu);
   public Object visit(NodeOptional n, Object argu);
   public Object visit(NodeSequence n, Object argu);
   public Object visit(NodeToken n, Object argu);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> schema()
    * f1 -> <SEMICOLON>
    * f2 -> ( constraint() <SEMICOLON> )*
    * f3 -> ( local_condition() <SEMICOLON> )*
    */
   public Object visit(MKBFile n, Object argu);

   /**
    * f0 -> <SCHEMA>
    * f1 -> <LPAREN>
    * f2 -> IS_definition()
    * f3 -> ( <COMMA> IS_definition() )*
    * f4 -> <RPAREN>
    */
   public Object visit(schema n, Object argu);

   /**
    * f0 -> ISName()
    * f1 -> <LPAREN>
    * f2 -> dbtype()
    * f3 -> <COLON>
    * f4 -> <LPAREN>
    * f5 -> DBURL()
    * f6 -> <COMMA>
    * f7 -> username()
    * f8 -> <COMMA>
    * f9 -> password()
    * f10 -> [ <COMMA> <BF> <EQUAL> blocking_factor() ]
    * f11 -> <RPAREN>
    * f12 -> [ <COMMA> relation_definition() ( <COMMA> relation_definition() )* ]
    * f13 -> <RPAREN>
    */
   public Object visit(IS_definition n, Object argu);

   /**
    * f0 -> <STRING>
    */
   public Object visit(DBURL n, Object argu);

   /**
    * f0 -> <LPAREN>
    * f1 -> RelationName()
    * f2 -> [ <LPAREN> <SIZE> <EQUAL> relation_size() <RPAREN> ]
    * f3 -> <COLON>
    * f4 -> attribute_definition()
    * f5 -> ( <COMMA> attribute_definition() )*
    * f6 -> <RPAREN>
    */
   public Object visit(relation_definition n, Object argu);

   /**
    * f0 -> AttributeName()
    * f1 -> [ <LPAREN> <SIZE> <EQUAL> attribute_size() <RPAREN> ]
    */
   public Object visit(attribute_definition n, Object argu);

   /**
    * f0 -> type_constraint()
    *       | join_constraint()
    *       | pc_constraint()
    */
   public Object visit(constraint n, Object argu);

   /**
    * f0 -> <TC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> <COLON>
    * f6 -> AttributeList()
    * f7 -> <RPAREN>
    */
   public Object visit(type_constraint n, Object argu);

   /**
    * f0 -> AttributeName()
    * f1 -> <IN>
    * f2 -> type()
    * f3 -> [ <COMMA> AttributeList() ]
    */
   public Object visit(AttributeList n, Object argu);

   /**
    * f0 -> <JC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> <JOIN>
    * f6 -> ISName()
    * f7 -> <DOT>
    * f8 -> RelationName()
    * f9 -> [ <LPAREN> <JS> <EQUAL> join_selectivity() <RPAREN> ]
    * f10 -> <COLON>
    * f11 -> attribute_pair()
    * f12 -> ( <COMMA> attribute_pair() )*
    * f13 -> <RPAREN>
    */
   public Object visit(join_constraint n, Object argu);

   /**
    * f0 -> <PC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> operator()
    * f6 -> ISName()
    * f7 -> <DOT>
    * f8 -> RelationName()
    * f9 -> <COLON>
    * f10 -> attribute_pair()
    * f11 -> ( <COMMA> attribute_pair() )*
    * f12 -> <RPAREN>
    */
   public Object visit(pc_constraint n, Object argu);

   /**
    * f0 -> <LC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> <DOT>
    * f6 -> AttributeName()
    * f7 -> boolean_operator()
    * f8 -> value()
    * f9 -> <LPAREN>
    * f10 -> <SEL>
    * f11 -> <EQUAL>
    * f12 -> local_selectivity()
    * f13 -> <RPAREN>
    * f14 -> <RPAREN>
    */
   public Object visit(local_condition n, Object argu);

   /**
    * f0 -> <LPAREN>
    * f1 -> AttributeName()
    * f2 -> <COMMA>
    * f3 -> AttributeName()
    * f4 -> <RPAREN>
    */
   public Object visit(attribute_pair n, Object argu);

   /**
    * f0 -> <LITERAL>
    */
   public Object visit(ISName n, Object argu);

   /**
    * f0 -> <LITERAL>
    */
   public Object visit(RelationName n, Object argu);

   /**
    * f0 -> <LITERAL>
    */
   public Object visit(AttributeName n, Object argu);

   /**
    * f0 -> <LITERAL>
    * f1 -> [ <LPAREN> typesize() <RPAREN> ]
    */
   public Object visit(type n, Object argu);

   /**
    * f0 -> <INTEGER>
    */
   public Object visit(typesize n, Object argu);

   /**
    * f0 -> <LITERAL>
    */
   public Object visit(dbtype n, Object argu);

   /**
    * f0 -> <STRING>
    */
   public Object visit(username n, Object argu);

   /**
    * f0 -> <STRING>
    */
   public Object visit(password n, Object argu);

   /**
    * f0 -> <INTEGER>
    */
   public Object visit(blocking_factor n, Object argu);

   /**
    * f0 -> <NOMORE>
    *       | <LESS>
    *       | <EQUAL>
    *       | <GREAT>
    *       | <NOLESS>
    */
   public Object visit(boolean_operator n, Object argu);

   /**
    * f0 -> <SUBSET>
    *       | <SUPERSET>
    *       | <EQUIV>
    *       | <APPROX>
    */
   public Object visit(operator n, Object argu);

   /**
    * f0 -> <INTEGER>
    */
   public Object visit(relation_size n, Object argu);

   /**
    * f0 -> <INTEGER>
    */
   public Object visit(attribute_size n, Object argu);

   /**
    * f0 -> <FLOAT>
    */
   public Object visit(join_selectivity n, Object argu);

   /**
    * f0 -> <INTEGER>
    *       | <FLOAT>
    *       | <SQLSTRING>
    */
   public Object visit(value n, Object argu);

   /**
    * f0 -> <FLOAT>
    */
   public Object visit(local_selectivity n, Object argu);

}
