//
// Generated by JTB 1.2
//

package DSRG.MKB.visitor;
import DSRG.MKB.syntaxtree.*;
import java.util.*;

/**
 * All void visitors must implement this interface.
 */
public interface Visitor {
   //
   // void Auto class visitors
   //
   public void visit(NodeList n);
   public void visit(NodeListOptional n);
   public void visit(NodeOptional n);
   public void visit(NodeSequence n);
   public void visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> schema()
    * f1 -> <SEMICOLON>
    * f2 -> ( constraint() <SEMICOLON> )*
    * f3 -> ( local_condition() <SEMICOLON> )*
    */
   public void visit(MKBFile n);

   /**
    * f0 -> <SCHEMA>
    * f1 -> <LPAREN>
    * f2 -> IS_definition()
    * f3 -> ( <COMMA> IS_definition() )*
    * f4 -> <RPAREN>
    */
   public void visit(schema n);

   /**
    * f0 -> ISName()
    * f1 -> <LPAREN>
    * f2 -> dbtype()
    * f3 -> <COLON>
    * f4 -> <LPAREN>
    * f5 -> DBURL()
    * f6 -> <COMMA>
    * f7 -> username()
    * f8 -> <COMMA>
    * f9 -> password()
    * f10 -> [ <COMMA> <BF> <EQUAL> blocking_factor() ]
    * f11 -> <RPAREN>
    * f12 -> [ <COMMA> relation_definition() ( <COMMA> relation_definition() )* ]
    * f13 -> <RPAREN>
    */
   public void visit(IS_definition n);

   /**
    * f0 -> <STRING>
    */
   public void visit(DBURL n);

   /**
    * f0 -> <LPAREN>
    * f1 -> RelationName()
    * f2 -> [ <LPAREN> <SIZE> <EQUAL> relation_size() <RPAREN> ]
    * f3 -> <COLON>
    * f4 -> attribute_definition()
    * f5 -> ( <COMMA> attribute_definition() )*
    * f6 -> <RPAREN>
    */
   public void visit(relation_definition n);

   /**
    * f0 -> AttributeName()
    * f1 -> [ <LPAREN> <SIZE> <EQUAL> attribute_size() <RPAREN> ]
    */
   public void visit(attribute_definition n);

   /**
    * f0 -> type_constraint()
    *       | join_constraint()
    *       | pc_constraint()
    */
   public void visit(constraint n);

   /**
    * f0 -> <TC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> <COLON>
    * f6 -> AttributeList()
    * f7 -> <RPAREN>
    */
   public void visit(type_constraint n);

   /**
    * f0 -> AttributeName()
    * f1 -> <IN>
    * f2 -> type()
    * f3 -> [ <COMMA> AttributeList() ]
    */
   public void visit(AttributeList n);

   /**
    * f0 -> <JC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> <JOIN>
    * f6 -> ISName()
    * f7 -> <DOT>
    * f8 -> RelationName()
    * f9 -> [ <LPAREN> <JS> <EQUAL> join_selectivity() <RPAREN> ]
    * f10 -> <COLON>
    * f11 -> attribute_pair()
    * f12 -> ( <COMMA> attribute_pair() )*
    * f13 -> <RPAREN>
    */
   public void visit(join_constraint n);

   /**
    * f0 -> <PC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> operator()
    * f6 -> ISName()
    * f7 -> <DOT>
    * f8 -> RelationName()
    * f9 -> <COLON>
    * f10 -> attribute_pair()
    * f11 -> ( <COMMA> attribute_pair() )*
    * f12 -> <RPAREN>
    */
   public void visit(pc_constraint n);

   /**
    * f0 -> <LC>
    * f1 -> <LPAREN>
    * f2 -> ISName()
    * f3 -> <DOT>
    * f4 -> RelationName()
    * f5 -> <DOT>
    * f6 -> AttributeName()
    * f7 -> boolean_operator()
    * f8 -> value()
    * f9 -> <LPAREN>
    * f10 -> <SEL>
    * f11 -> <EQUAL>
    * f12 -> local_selectivity()
    * f13 -> <RPAREN>
    * f14 -> <RPAREN>
    */
   public void visit(local_condition n);

   /**
    * f0 -> <LPAREN>
    * f1 -> AttributeName()
    * f2 -> <COMMA>
    * f3 -> AttributeName()
    * f4 -> <RPAREN>
    */
   public void visit(attribute_pair n);

   /**
    * f0 -> <LITERAL>
    */
   public void visit(ISName n);

   /**
    * f0 -> <LITERAL>
    */
   public void visit(RelationName n);

   /**
    * f0 -> <LITERAL>
    */
   public void visit(AttributeName n);

   /**
    * f0 -> <LITERAL>
    * f1 -> [ <LPAREN> typesize() <RPAREN> ]
    */
   public void visit(type n);

   /**
    * f0 -> <INTEGER>
    */
   public void visit(typesize n);

   /**
    * f0 -> <LITERAL>
    */
   public void visit(dbtype n);

   /**
    * f0 -> <STRING>
    */
   public void visit(username n);

   /**
    * f0 -> <STRING>
    */
   public void visit(password n);

   /**
    * f0 -> <INTEGER>
    */
   public void visit(blocking_factor n);

   /**
    * f0 -> <NOMORE>
    *       | <LESS>
    *       | <EQUAL>
    *       | <GREAT>
    *       | <NOLESS>
    */
   public void visit(boolean_operator n);

   /**
    * f0 -> <SUBSET>
    *       | <SUPERSET>
    *       | <EQUIV>
    *       | <APPROX>
    */
   public void visit(operator n);

   /**
    * f0 -> <INTEGER>
    */
   public void visit(relation_size n);

   /**
    * f0 -> <INTEGER>
    */
   public void visit(attribute_size n);

   /**
    * f0 -> <FLOAT>
    */
   public void visit(join_selectivity n);

   /**
    * f0 -> <INTEGER>
    *       | <FLOAT>
    *       | <SQLSTRING>
    */
   public void visit(value n);

   /**
    * f0 -> <FLOAT>
    */
   public void visit(local_selectivity n);

}

