////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.MW;

import java.io.*;
import java.util.*;
import EVEDemo.MW.*;

/**
 * Class that encapsulates data we need to create and
 * manipulate SQL queries on.
 * @author Jeff Moyer <phro@wpi.edu>
 */
public class ISQuery{

  /**
   * Name of the IS
   */
  private String Name;

  /**
   * Select clause
   */
  private String Select;

  /**
   * From clause
   */
  private String From;

  /**
   * Where Clause
   */
  private String Where;

  /**
   * Our part of the SQL statement.
   */
  private String SQLStatement;

  /**
   * Constructor - Merely initializes some values.
   * @param name The name of this particular IS
   * @param sqlstatement An sql statement that deals only with this IS.
   */
  public ISQuery(String ISname, String sel, String frm, String whr){
    // Here we merely initialize some values.  No actual work is done.
    Name = ISname;
    this.Select = sel;
    this.From = frm;
    this.Where = whr;
    SQLStatement = "select "+Select+" from "+From;
    if (Where.length()>0) SQLStatement += " where "+Where;
  }

  /**
   * @return Name of the Query
   */
  public String getName(){
    return Name;
  }


  /**
   * @return string containing the select clause for this IS.
   */
  public String getWhere(){
    return(Where);
  }

  /**
   * @return string containing the project clause for this IS.
   */
  public String getSelect(){
    return(Select);
  }

  /**
   * @return string containing the join clause for this IS.
   */
  public String getFrom(){
    return(From);
  }

  /**
   * @return string containing the SQL Statement for this IS.
   */
  public String getSQLStatement(){
    return(SQLStatement);
  }

}
