////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.VKB.E_SQL;

import DSRG.MKB.Relation;
import DSRG.MKB.Attribute;

/**
* Interface between E_SQL (SimpleNode) and MKB.
* It will create a stub MKB for VKB using.
*/
public interface E_SQL_MKB 
{
  /**
  * Create a new Relation in MKB. Used by SimpleNode
  */
  public abstract Relation createRelation(String IS_name, String rel_name);

  /**
  * Create a new Attribute in MKB, Used by SimpleNode
  */
  public abstract Attribute createAttribute(String IS_name, String rel_name, String attr_name);


}

