////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.VKB;

import java.io.Serializable;

/**
* This class represents the operator between two operands.
*/
public final class Operator implements java.io.Serializable
{
  /**
  * is "=="
  */
  final static String EQUAL = "==";
  /**
  * is ">"
  */
  final static String GREATTHAN = ">";
  /**
  * is "<"
  */
  final static String LESSTHAN = "<";
  /**
  * is "!="
  */
  final static String NOEQUAL = "!=";
  /**
  * is ">="
  */
  final static String NOTLESSTHAN = ">=";
  /**
  * is "<="
  */
  final static String NOTGREATETHAN = "<=";

  /**
  * Current Value of the Operator
  */
  String Value;

  /** Initialize the Operand.
  * The Default value is EQUAL
  */
  public Operator(String op){

    Value = op;

  }

  /**
  * Conver this operator to String.
  */
  public String toString(){

    return Value;

  }

  /**
  * Used to compare what is this operator
  * @param in String. It could be ">", "<", ">=", "<=", "=="
  */
  public boolean equals(String in){
	  return Value.equals(in);
  }
}
