////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.VKB;

/**
* Primitive Value will include long, double, and string.
* They are based on the Primitive Type of Oracle;
*/
public class Primitive_Value implements java.io.Serializable
{
  String StringValue;
  long longValue;
  double doubleValue;
  boolean BooleanValue;
  int type;

  private Primitive_Value(){
    type = Type.OTHER;
    StringValue = new String();
  }

  public Primitive_Value(long newValue){
    this();

    longValue = newValue;
    type = Type.LONG;
  }

  public Primitive_Value(double newValue){
    this();

    doubleValue = newValue;
    type = Type.DOUBLE;
  }

  public Primitive_Value(boolean newValue){
    this();

    BooleanValue = newValue;
    type = Type.BOOLEAN;
  }

  public Primitive_Value(String newValue){
    this();

    StringValue = newValue;
    type = Type.STRING;
  }

  public long getLong(){
    return longValue;
  }

  public double getDouble(){
    return doubleValue;
  }

  public boolean getBoolean(){
    return BooleanValue;
  }

  public String getString(){
    return StringValue;
  }

  public int getType(){
    return type;
  }

  public String toString(){
    switch(type){
    case Type.LONG:
      return new Long(longValue).toString();
    case Type.DOUBLE:
      return new Double(doubleValue).toString();
    case Type.BOOLEAN:
      if(BooleanValue)
        return "TRUE";
      else
        return "FALSE";
    case Type.STRING:
      return StringValue;
    default:
      System.out.println("Primitive_Value:toString() unknow Type");
      break;
    }
    return null;
  }
}

