////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.VKB;

import DSRG.MKB.IS;
import DSRG.MKB.Relation;

/**
* It's the relation component. It's a part of FROM clause.
*/
public class Relation_Component extends View_Component implements java.io.Serializable, Cloneable
{
  /**
  * Relation reference stored in MKB.
  * I have stub class for it.
  */
  Relation rel;

  /**
  * get name. It's like "R"
  */
  public String getName(){
    return rel.getName();
  }

  /**
  * Set Relation reference of this Component
  */
  public void setRelation(Relation r){
    rel = r;
  }

  /**
  * Get Relation reference of this component
  */
  public Relation getRelation(){
    return rel;
  }

  /**
  * Display Relation Component
  */
  public String toString(){
    return rel.getFullName() + displayEvolvingParameter("RD", "RR");
  }

  /**
  * Default Constructor for Relation Component
  */
  public Relation_Component(){
    super();
  }

  /**
  * Constructor for Relation Component for a Relation
  * @param r the Relation of this component
  * @param dis Dispensable
  * @param rep Replaceable
  */
  public Relation_Component(Relation r, boolean dis, boolean rep){
    this();
    rel = r;
    Dispensable = dis;
    Replaceable = rep;
  }

    /**
     * returns the IS name of this relation
     */
    public String getISName() {
        return ((IS)rel.getIS()).getName();
    }


    /**
     * returns the IS object of this relation
     */
    public IS getIS() {
        return rel.getIS();
    }

    /**
     * Clone the Relation_Component.
     */
    public Object clone(){
	Relation_Component rc = new Relation_Component();
	rc.rel = rel;
	rc.Dispensable = Dispensable;
	rc.Replaceable = Replaceable;

	if(EVEDemo.MW.Main.DEBUG)System.out.println("Relation_Component.clone()");
	return rc;
    }

}







