////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.VKB;

import java.util.StringTokenizer;
import java.io.Serializable;

/**
* Type will implement some of Oracle's types.
*/
public final class Type implements java.io.Serializable
{
  public final static int LONG = 0;
  public final static int DOUBLE = 1;
  public final static int BOOLEAN = 2;
  public final static int STRING = 3;
  public final static int DATE = 4;
  public final static int OTHER = -1;

  int currentType;

  public Type(int newType){
    currentType = newType;
  }

  public static boolean isDate(String t){
    try{
      if(t.substring(0,2).equals("19") && t.charAt(4)=='-' && t.charAt(7)=='-')
        return true;
    }catch(Exception e){
      // do nothing here.
    }
    return false;
  }

  public static String DateTransfer(String t){
    StringBuffer sb = new StringBuffer();

    StringTokenizer ston = new StringTokenizer(t, "- ");

    String Year = ston.nextToken().substring(2,4);
    String Mon = ston.nextToken();
    String Day = ston.nextToken();

    try{
      sb.append(Day + "-" + month(Mon) + "-" + Year);
    }catch(NoSuchMonthException nsme){
      System.out.println("Type:DateTransfer() " + nsme.getMessage());
    }

    return sb.toString();
  }

  public static String month(String mon) throws NoSuchMonthException{
    Integer i = new Integer(mon);

    switch(i.intValue()){
    case 1:
      return "JAN";
    case 2:
      return "FEB";
    case 3:
      return "MAR";
    case 4:
      return "APR";
    case 5:
      return "MAY";
    case 6:
      return "JUN";
    case 7:
      return "JUL";
    case 8:
      return "AUG";
    case 9:
      return "SEP";
    case 10:
      return "OCT";
    case 11:
      return "NOV";
    case 12:
      return "DEC";
    }
    
    throw new NoSuchMonthException();
  }
}

