////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.VSA;

import DSRG.MKB.Relation;
import DSRG.MKB.Attribute;

import java.util.Hashtable;

/**
* Substituted Relations and Attributes Hashtable.
*/
public class Replacement implements java.io.Serializable
{
  /**
  * Reference of Relation in MKB. It is the substituted relation.
  */
  public Relation rel;
  
  /**
  * It's a hashtable of attribute paires. It index on the reference of 
  * affected attribute in MKB, and the element of it is the reference of
  * substitute attribute in MKB.
  */
  public Hashtable attr_pairs;

  /**
  * Default constructor. Set everything to null.
  */
  public Replacement(){
    rel = null;
    attr_pairs = null;
  }

}

