////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package DSRG.VSA;

import java.util.Vector;
import DSRG.VKB.View_Definition;

/**
* Interface between VSA and VKB
*/
public interface VSA_VKB 
{

  /**
  * Drop a set of view definitions specified in Vector VDs from VKB.
  */
  public abstract void dropSetOfVDs(Vector VDs);

  /**
  * Replace view V with bestV.
  */
  public abstract void replaceViewDefinition(View_Definition V, View_Definition bestV);

  /**
  * Drop one Attribute Component
  */
  //public abstract void drop(Attribute_Component ac);
  /**
  * Drop one Relation Component
  */
  //public abstract void drop(Relation_Component rc);
  /**
  * Drop one Condition Component
  */
  //public abstract void drop(Condition_Component cc); 

  /**
  * Find all components reference to specific relation
  */
  //public abstract Vector findComponents(String IS_name, String Rel_name);
  /**
  * Find all components reference to specific attribute
  */
  //public abstract Vector findComponents(String IS_name, String Rel_name, String Attr_name);

  /**
  * change one attribute component reference to another attribute
  */
  //public abstract void replaceComponentReference(Attribute_Components ac, Attribute ref);
  /**
  * change one relation component reference to another relation
  */
  //public abstract void replaceComponentReference(Relation_Components ac, Relation ref);
  /**
  * change one condition component reference to another condition
  */
  //public abstract void replaceComponentReference(Condition_Components ac, Condition ref);

  /**
  * get affected views by relation name
  */
  public abstract Vector getViewDefinitions(String IS_name, String Rel_name);
  /**
  * get affected views by attribute name
  */
  public abstract Vector getViewDefinitions(String IS_name, String Rel_name, String Attr_name);
}

