////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package EVEDemo.ISChangeApplet;

import EVEDemo.MW.*;
import DSRG.MW.*;
import java.lang.*;
import java.util.*;
import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;

/**
 * This class creates a frame which confirms whether the user would like to delete
 * the selected item.  It is shown only when Delete Attribute or Delete Relation is
 * selected on an instance of ISChange
 *
 * @author Amber Van Wyk, Summer 1998
 *
 */
public class delFrame extends JFrame
{
    JButton yes;
    JButton no;
    JPanel buttons;
    JLabel confirm;

    /**
     * Class constructor. <BR>
     * Initializes objects on the frame
     */
	public delFrame()
	{
	  // Initialize Frame
	  setTitle("Really Delete?");
	  setResizable(false);
	  setSize(450,100);
	  getContentPane().setLayout(new GridLayout(2, 1, 20, 20));
	  
	  // Initialize confirm label
	  confirm = new JLabel("Are you sure you want to delete? ", SwingConstants.CENTER);
	  confirm.setFont(new Font("Dialog", Font.PLAIN, 14));
	  confirm.setForeground(Color.blue);
	  confirm.setSize(300, 25);
	  
	  // Initialize buttons and place on button panel
	  yes = new JButton("YES");
	  no = new JButton("NO");
	  buttons = new JPanel();
	  buttons.add(yes);
	  buttons.add(no);
	  
	  // Add label and buttons to frame
	  getContentPane().add(confirm);
	  getContentPane().add(buttons);
	}
  
  /**
   * (mostly generated by Visual Cafe)
   * in addition to setting visibility, also sets location
   */
  public synchronized void setVisible(boolean show)
    {
      if(show)
	{
	  setLocation(100, 100);
	  super.setVisible(true);
	}
      else
	{
	  super.setVisible(false);
	}
    }
  
  /**
   * (generated by Visual Cafe)
   */
  public void addNotify()
    {
      // Record the size of the window prior to calling parents addNotify.
      Dimension d = getSize();
      
      super.addNotify();
      
      if (fComponentsAdjusted)
	return;
      
      // Adjust components according to the insets
      setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
      Component components[] = getComponents();
      for (int i = 0; i < components.length; i++)
	{
	  Point p = components[i].getLocation();
	  p.translate(getInsets().left, getInsets().top);
	  components[i].setLocation(p);
	}
      fComponentsAdjusted = true;
    }
  
  /**
   * Used for addNotify check.
   */
  boolean fComponentsAdjusted = false;
  
  /**
   * (generated by Visual Cafe)
   */
  class SymWindow extends java.awt.event.WindowAdapter
  {
    public void windowClosing(java.awt.event.WindowEvent event)
      {
	Object object = event.getSource();
	if (object == delFrame.this)
	  Frame1_WindowClosing(event);
      }
  }
  
  /**
   * (generated by Visual Cafe)
   */
  void Frame1_WindowClosing(java.awt.event.WindowEvent event)
    {
      setVisible(false);		 // hide the Frame
    }
  
  /**
   * Set text for question confirming deletion
   */
  public void setQuestion(String question)
    {
      try{
	confirm.setText(question);
      }catch(Exception e){
	System.out.println(e);
      }
    }
}
