////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package EVEDemo.ISChangeApplet;

import EVEDemo.MW.*;
import DSRG.MW.*;
import java.lang.*;
import java.util.*;
import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;

/**
 * This class creates a frame which displays a message
 *
 * @author Amber Van Wyk, Summer 1998
 */
public class myMessageBox extends JFrame
{
    JButton ok;
    JPanel buttons;

	/**
	 * Class Constructor. <BR>
	 * Shows the message and an OK message
	 */
	public myMessageBox(String message)
	{
        setTitle("Just A Note");
		setResizable(false);
		setSize(400,100);
        getContentPane().setLayout(new GridLayout(2, 1, 15, 15));

		JLabel oops = new JLabel(message, SwingConstants.CENTER);
		oops.setFont(new Font("Dialog", Font.PLAIN, 14));
        oops.setForeground(Color.blue);

		ok = new JButton("OK");
        buttons = new JPanel();
        buttons.add(ok);

		getContentPane().add(oops);
		getContentPane().add(buttons);

		// (generated by Visual Cafe)
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		ok.addMouseListener(aSymMouse);
	}

    /**
     * (mostly generated by Visual Cafe) <BR>
     * in addition to setting visibility, sets the location for the frame
     */
	public synchronized void setVisible(boolean show)
	{
	    if(show)
	    {
		    setLocation(100, 100);
		    super.setVisible(true);
		}
		else
		{
		    super.setVisible(false);
		}
	}

    /**
     * (generated by Visual Cafe)
     */
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    /**
     * Used for addNotify check.
     */
	boolean fComponentsAdjusted = false;

    /**
     * (generated by Visual Cafe)
     */
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == myMessageBox.this)
				Frame1_WindowClosing(event);
		}
	}

    /**
     * (generated by Visual Cafe)
     */
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

    /**
     * (mostly generated by Visual Cafe)
     * listner for mouse clicks
     */
	class SymMouse extends java.awt.event.MouseAdapter
	{
		/**
		 * catches mouse clicks
		 */
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if(object == ok)
			    ok_MouseClicked();
		}
	}

    /**
     * Hide frame
     */
	public void ok_MouseClicked()
	{
	    setVisible(false);
	}
}
