////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package EVEDemo.ISChangeApplet;

import EVEDemo.MW.*;
import DSRG.MW.*;
import java.lang.*;
import java.util.*;
import java.awt.*;
import com.sun.java.swing.*;
import com.sun.java.swing.table.*;
import com.sun.java.swing.event.*;

/**
 * This class creates a frame which asks for the new name of the attribute or relation and confirms
 * changing the name.  It is shown only when Rename Attribute or Rename Relation is selected from
 * an instance of ISChange
 *
 * @author Amber Van Wyk, Summer 1998
 */
public class renFrame extends JFrame
{
    JButton ok;
    JButton cancel;
    JLabel oldName;
    JLabel newName;
    JTextField oldTF;
    JTextField newTF;
    JPanel buttons;
    JPanel oldStuff;
    JPanel newStuff;

    /**
     * Class Constructor. <BR>
     * Initializes objects on the frame
     */
	public renFrame()
	{
	    // Initialize Frame
        setTitle("Change Name?");
		setResizable(false);
		setSize(450,125);
		getContentPane().setLayout(new GridLayout(3, 1, 10, 10));

        // Initialize objects for old name information
        oldName = new JLabel("Old Name: ");
        oldName.setFont(new Font("Dialog", Font.PLAIN, 14));
        oldName.setForeground(Color.blue);
        oldTF = new JTextField();  // set by method when necessary
        oldTF.setPreferredSize(new Dimension(350, 25));
        oldTF.setEditable(false);
        oldStuff = new JPanel();
        oldStuff.add(oldName);
        oldStuff.add(oldTF);

        // Initialize objects for new name information
        newName = new JLabel("New Name: ");
        newName.setFont(new Font("Dialog", Font.PLAIN, 14));
        newName.setForeground(Color.blue);
        newTF = new JTextField();  // filled in by user
        newTF.setPreferredSize(new Dimension(350, 25));
        newStuff = new JPanel();
        newStuff.add(newName);
        newStuff.add(newTF);

        // Initialize objects for buttons
        ok = new JButton("OK");
        cancel = new JButton("Cancel");
        buttons = new JPanel();
        buttons.add(ok);
        buttons.add(cancel);

        // Add label and buttons to frame
        getContentPane().add(oldStuff);
        getContentPane().add(newStuff);
        getContentPane().add(buttons);
	}

    /**
     * (mostly generated by Visual Cafe) <BR>
     * in addition to setting visibility, sets location of the frame
     */
	public synchronized void setVisible(boolean show)
	{
	    if(show)
	    {
		    setLocation(100, 100);
		    newTF.requestFocus();
		    super.setVisible(true);
		}
		else
		{
		    super.setVisible(false);
		}
	}

    /**
     * (generated by Visual Cafe)
     */
	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    /**
     * Used for addNotify check.
     */
	boolean fComponentsAdjusted = false;

    /**
     * (generated by Visual Cafe)
     */
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == renFrame.this)
				Frame1_WindowClosing(event);
		}
	}

    /**
     * (generated by Visual Cafe)
     */
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

    /**
     * Sets the text in the text field which containst the old (current) name of the item
     */
	public void setOldName(String nameIn)
	{
	    oldTF.setText(nameIn);
	    newTF.setText("");
	}

    /**
     * gets the new name for the item
     */
	public String getNewName()
	{
	    return newTF.getText();
	}
}
