////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package EVEDemo.MKBVKBApplet;

import com.sun.java.swing.table.*;

/**
 * This class is the table model for my tables. It will disallows editing of cells.  If later,
 * it is desirable to have the cells be editable, information *may* be found at
 * http://java.sun.com/docs/books/tutorial/ui/swing/table.html
 * which is where information leading to construciton of this class was found
 *
 * @author Amber Van Wyk, Summer 1998
 */
class MyTableModel extends AbstractTableModel {

    String[] columnNames;
    Object[][] data;

    /**
     * Class Constructor
     */
    public MyTableModel(String[] columnNamesIn, Object[][] dataIn)
    {
        columnNames = columnNamesIn;
        data = dataIn;
    }

    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data.length;
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        return data[row][col];
    }

    /**
     * JTable uses this method to determine the default renderer/
     * editor for each cell.
     */
    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }


}