////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package EVEDemo.MKBVKBApplet;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import com.sun.java.swing.*;
import EVEDemo.MW.*;
import DSRG.MW.*;


/**
 * Creates an applet which lets the user choose to browse the mkb or
 * the vkb <BR> The first thing that occurs when creating an instance
 * of this class is that it attempts to connect to the server
 * "mwMainServer" <BR> It creates an instance of mkbFrame and vkbFrame
 * and hides and shows these frames as needed.  <BR> It contains a
 * timer which periodically checks to see if there have been updates
 * to the MKB and VKB, and if so, each frame is updated.  <P> comment
 * 030799 koeller: phasing out RMI-Support
 *  @author Amber Van Wyk, Summer 1998 */
public class mkbvkb extends JFrame
{
  /**
   * An instance of the main class.
   */
  public EVEDemo.MW.Main mwMain; // = new EVEDemo.MW.Main();
  
  /**
   * A Vector to contain all of the ISObjects
   */
  public Vector allISObjects = new Vector();
  
  /**
   * A Vector to contain all of the Views
   */
  public Vector allViews = new Vector();
  
  /**
   * Timer to refresh automatically when necessary
   */
  private Timer refreshTimer;
  
  /**
   * handle to eve.properties
   */
  Properties props;
  
  JLabel lblWelcome;
  JButton mkbBrowse;
  JButton vkbBrowse;
  //JButton refresh;  // this button's code has been commented out.  it was originally used to test the
  // refresh mechanism which is now called by the timer
  vkbFrame vFrame;
  mkbFrame mFrame;

  /**
   * Counter to show the executing time. :)
   */
  //Counter c;

  public void start(){
    //if(c == null){
    //c = new Counter(this);
    //c.start();
    //}
  }

  public void stop(){
    //if(c != null){
    //c.destory();
    //c = null;
    //}
  }

  public void destroy(){
    stop();
    System.out.println("Destroying applet");
  }

  boolean init_status=false;

  public mkbvkb(Main mn){
    super("MKB VKB Browser");
    mwMain = mn;
    init();
    setSize(new Dimension(400,200));
    setLocation(400,0);
    toFront();
    show();
  }

  /**
   *  Connect to the server "mwMainServer" and then initialize all objects on the applet
   */
  public void init()
    {
      //c = new Counter(this);
      //c.start();

      init_status = true;
      //      System.out.println("Begin init...");

      
      // Get all InformationSources and Views from mwMain
      try{
	allISObjects = mwMain.getMKB().getISs();
      }catch(Exception e){
	System.out.println("Debug:mkbvkb.init() What's Wrong on Main.getAllISs()?");
	e.printStackTrace();
      }

      try{
	// System.out.println("Debug:mkbvkb.init() First Time.");
	allViews = mwMain.getAllViews();
       	//System.out.println("Debug:mkbvkb.init() GetAView(0):" + mwMain.getAView(0));
      }catch(Exception e) {
	System.out.println("Debug:mkbvkb.init() Error on Main.getAllViews().");
	e.printStackTrace();
      }
      
      getContentPane().setLayout(new GridLayout(4, 1, 150, 10));
      
      lblWelcome = new JLabel("View Site", JLabel.CENTER);
      lblWelcome.setFont(new Font("Dialog", Font.PLAIN, 36));
      lblWelcome.setForeground(new Color(128, 0, 128));
      getContentPane().add(lblWelcome);
      
      mkbBrowse = new JButton();
      mkbBrowse.setActionCommand("button");
      mkbBrowse.setText("Browse the MKB");
      mkbBrowse.setFont(new Font("Dialog", Font.PLAIN, 17));
      getContentPane().add(mkbBrowse);
      
      vkbBrowse = new JButton();
      vkbBrowse.setActionCommand("button");
      vkbBrowse.setText("Browse the VKB");
      vkbBrowse.setFont(new Font("Dialog", Font.PLAIN, 17));
      getContentPane().add(vkbBrowse);
      
      //refresh = new JButton();
      //refresh.setText("Refresh mkb and vkb");
      //refresh.setFont(new Font("Dialog", Font.PLAIN, 17));
      //getContentPane().add(refresh);
      
      SymMouse aSymMouse = new SymMouse();
      mkbBrowse.addMouseListener(aSymMouse);
      vkbBrowse.addMouseListener(aSymMouse);
      //refresh.addMouseListener(aSymMouse);
      
  /*    try{
	
	// System properties will be the parent of these properties
	props = new Properties(System.getProperties());
	props.load(new BufferedInputStream(new FileInputStream("eve.properties")));
	System.setProperties(props);
      }
      catch(Exception e)
        {
	  e.printStackTrace();
        }
      
      String d = props.getProperty("delay");
      int delay = (new Integer(d)).intValue();*/

      init_status = false;

      // Here the get properties will cause SecurityProblem. So, I just omit it.
      int delay = 15000;  

      refreshTimer = new Timer(delay, new TimerListener());
      refreshTimer.start();
    }

  /**
   * the actionPerformed method in this class
   * is called each time the Timer "goes off"
   */
    class TimerListener implements ActionListener
    {
        public void actionPerformed(ActionEvent evt)
        {
	  if (EVEDemo.MW.Main.DEBUG) System.out.println("Timer went off");
	  /*	  try{// RMI-Exception */
	    if(mwMain.getChangeStatus())
	      {
		refresh();
	      }
	    /*	  }catch(java.rmi.RemoteException e){
	    e.printStackTrace();
	    }*/
        }
    }

    /**
     * Sets up a listener to listen for mouse clicks
     */
	class SymMouse extends java.awt.event.MouseAdapter
	{
		/**
		 * Catches mouse click
		 */
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == mkbBrowse)
				mkbBrowse_MouseClick(event);
			else if (object == vkbBrowse)
			    vkbBrowse_MouseClick(event);
			//else if (object == refresh)
			  //  refresh();
		}
	}

    /**
     * Called by mouseClick when mkbBrowse button is clicked
     */
	void mkbBrowse_MouseClick(java.awt.event.MouseEvent event)
	{
		mFrame = new mkbFrame(mwMain);
		mFrame.setVisible(true);
	}

	/**
	 * Called by mouseClick when vkbBrowse button is clicked
	 */
	void vkbBrowse_MouseClick(java.awt.event.MouseEvent event)
	{
	  // System.out.println("Debug:mkbvkb.vkbBrowse_MouseClick the First View Here is:" + 
	  // ((View)allViews.elementAt(0)).getDefinition());
	  vFrame = new vkbFrame(allViews, mwMain);// Modified by Xin, only add one parameter: mwMain
	  vFrame.setVisible(true);
	}

	/**
	 * Rebuilds the mkb and vkb by getting all InformationSources and Views from mwMain again
	 */
	void refresh()
	{
            allISObjects = null; allViews = null;
	  // System.out.println("Rebuild mkb and vkb");
	    try{
	        allISObjects = mwMain.getMKB().getISs();
		// System.out.println("Debug:mkbvkb.refresh() Second or more times.");
	        allViews = mwMain.getAllViews();
	    }catch(Exception e){
	      System.out.println("got an exception getting all ");

	      e.printStackTrace();
	    }
	    
	    // Update mFrame only if it has already been initialized.
	    if(mFrame != null)
	      {
		mFrame.buildMkbTree(allISObjects);
		mFrame.resetConstraintArea();
		
		mFrame.lblSelectedNode.setText("The MKB has been updated");
		mFrame.invalidate();
		mFrame.validate();
		mFrame.repaint();
	      }
	    if(vFrame != null)
	      {
                // System.out.println("DEBUG: mkbvkb::refresh(). VFrame being updated");
		vFrame.initViewList(allViews);
		vFrame.invalidate();
		vFrame.validate();
		vFrame.repaint();
	      }
	}
}

class Counter extends Thread{

  boolean execute = true;

  Applet app;

  int i;

  public Counter( Applet theapp){
    app = theapp;
    i=0;
    execute = true;
  }

  public void run(){
    while(execute){
      try{
	app.showStatus("Running " + i + " seconds");
	sleep(1000);
	i++;
      }catch(Exception e){
	System.out.println("counter cannot sleep !");
      }
    }
    System.out.println("counter is destoried!");    
  }

  public void destory(){
    execute = false;
  }
}


