////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package EVEDemo.MW;

import java.util.Properties;
import java.io.*;
import DSRG.MW.*;

/** this class is executable from the command-line (java
 *    EVEDemo.MW.resetDB) and resets the Oracle database specified in
 *    "eve.properties" */

class resetDB {
    
    /** the one and only method in this class */
    public static void main (String[] s) {
        
        Properties props = null;
	try{
            
	    props = new Properties(System.getProperties());
	    props.load(new BufferedInputStream(new FileInputStream("eve.properties")));
	    System.setProperties(props);
	}catch(Exception e){
	    e.printStackTrace();
	}
        
        String resetDBFlag = System.getProperty("resetDB");
        String resetDBConnectString = 
            System.getProperty("resetDBConnectString");
        String resetDBUsername = 
            System.getProperty("resetDBUsername");
        String resetDBPassword = 
            System.getProperty("resetDBPassword");
        String resetDBFilename = 
            System.getProperty("resetDBFilename");
        
	
	if (resetDBFlag.equals("true")) {
	    DBMOracle reset = new DBMOracle("resetting",
                                            resetDBUsername,
                                            resetDBPassword, 
                                            resetDBConnectString);
	    reset.resetDB(resetDBFilename);
	    System.out.println("Oracle Database reset successfully");
	}
	else
	    System.out.println("Oracle Database has not been reset.");
    }
}

