////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package PSWEEP;

import java.util.Date;

import SWEEP.MultiQueue;
import SWEEP.Queue;
import SWEEP.UpdateData;

public class AssignTimeStamp extends SWEEP.LogUpdates implements java.io.Serializable{

  /**
   * The local time stamp of Data warehouse.
   */
  long timestamp = 0; 

  public AssignTimeStamp(MultiQueue theFIFO, Queue theMessageQueue){
    
    super(theFIFO, theMessageQueue);
  }

  /**
   * Reset TimeStamp before it overflow.
   */
  public void resetTimeStamp(){
  	timestamp = 0;
  }

  public synchronized long nextStamp(){
    return ++timestamp;
  }

  public void run(){
  
    while(!finished){
      
      try{
        // Receive Delta R from Data Source i
        UpdateData theUpdate= publicFIFOChannel.receive();

        // Assign time stamp on it 
      	//
      	//theUpdate.setTimeStamp();
      	//
      	// Here we ignore it, because we can use the default time stamp, but it should 
      	// be assigned here, instead of assigned at the time of creating the object.
      	// and one solution for it, maybe a combination of the time and id number.


        // Append (DeltaR, i) TO UpdateMessageQueue
        UpdateMessageQueue.Append(theUpdate);

      	System.out.println("AssignTimeStamp:run() Update " + theUpdate.getTimeStamp() + ":" + timestamp + " logged");

        //System.out.println("AssignTimeStamp:run() Update Logged" + theUpdate);
      }catch(Exception e){
        
        //System.out.println("AssignTimeStamp::run: " + e.getMessage());
        
        try{
          // have a rest and try again.
          sleep(PSWEEP.step);
        }catch(Exception e1){
          
          System.out.println("AssignTimeStamp::run: I cannot sleep because " + e1.getMessage());
        }
        
      }
    }
  }
}
