////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package PSWEEP;

/**
* Implement a lock for transactions.
*/
public class Lock{

  /**
  * A lock flag.
  */
  boolean theLock = false;


  /**
  * Initialize the lock.
  */
  public Lock(){
    theLock = false;
  }

  /**
  * Assign a lock.
  */
  public synchronized void lock(){

    if(theLock == true){
      try{
        if(EVEDemo.MW.Main.DEBUG) System.out.println("Lock:waitUnLock() wait for unlock!");
        wait();
      }catch(InterruptedException ie){
        ie.printStackTrace();
      }
    }

    theLock=true;
    if(EVEDemo.MW.Main.DEBUG)
      System.out.println("Lock:lock() Locked: " + theLock + " locks. ");
  }

  /**
  * Released a lock
  */
  public synchronized void unlock(){
    theLock = false;
    if(EVEDemo.MW.Main.DEBUG)
      System.out.println("Lock:unlock() notify the waiting to continue.");
    notify();
  }

}
