////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
//
//
// Attribute
//
//

// The Attribute will include Name(, Type, Size) and RelationReferences
public class Attribute implements java.io.Serializable
{
  Relation R;
  String  Name;
  Type  type;
  int  size;

  /**
  * Return Name of this Attribute.
  */
  public String getName(){
    return Name;
  }

  /**
  * Parameter: newSize is the number of newTypes.
  * e.g. long[2], the newSize is 2.
  */
  public Attribute(String newName, Relation Father, Type newType, int newSize)throws Exception{
    //check Para
    if(newName == null || Father == null || newType == null || newSize < 0)
      throw new Exception("Attribute:Attribute() Parameter Error");

    //Init
    Name = newName.substring(0);
    R = Father; // Relation Reference
    type = newType; // Here Type should be some final class
                    // and only has final static members to show the type.
    size = newSize;
  } 

  // Need to be done:
  // 1. getSQL()
  // 2. Consider add it in the Relation Class Definition, 
  //    at least in the RelationSchema Class
  // The getSQL will return Attribute name with Relation name. e.g. R.A
  public String getSQL(){

    return R.getName() + "." + Name;

  }

  /**
  * Return Relation REFERENCE of this attribute
  */
  public Relation getRelation(){
    return R;
  }
}

