////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
// This process will run on DW side
// It include three sub process
//            LogUpdates
//            UpdateView (calls ViewChange)
// It still include the public FIFO channel
// Inside the Process, it has it private queue: UpdateMessageQueue
// This process will generate the Delta View.

public class DWProcess implements java.io.Serializable{

  MultiQueue publicFIFOChannel;// public FIFO channel that connect IS and DW
  MessageQueue UpdateMessageQueue; // private Queue for holding all IS Updates

  LogUpdates currentLogUpdates; // this process will monitor the public FIFO channel and get elements from public FIFO channel to Update Message Queue
  public UpdateView currentUpdateView; // this process will monitor the private Update Message Queue and process the (Delta R, i) 

  ViewDefinition currentDW; // the View definition of current DW. From the 
  //algorithm, the View should be same as the Relation type. But, from the 
  //View is a SQL definition, and PSJ model is different with the Relation. 
  //So, I need to create a new ViewDefinition class as the sub class of 
  //Relation class.

  public DWProcess(MultiQueue FIFOChannel, ViewDefinition theDW)
  {
    // keep the public FIFO channel
    publicFIFOChannel = FIFOChannel;

    // keep ViewDefinition
    currentDW = theDW;

    // new deltaV
    Relation deltaV = new Relation("DeltaV");

    // create the private Queue
    UpdateMessageQueue = new MessageQueue();

    // create Thread LogUpdate
    currentLogUpdates = new LogUpdates(publicFIFOChannel, UpdateMessageQueue);

    // create Thread UpdateView
    currentUpdateView = new UpdateView(publicFIFOChannel, UpdateMessageQueue, currentDW);
  }

}




