////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
// ISProcess: the Process will running on IS
// It will include two sub processes:
//         ProcessQuery
//         SendUpdate
// This process still keep the public FIFO channel
// The process will not pass the sub queue to sub process seperately, because
// we need the whole process FIFO


public class ISProcess implements java.io.Serializable{

  MultiQueue publicFIFOChannel;// global object for SWEEP
  public SendUpdates currentUpdates;// SendUpdates Process
  public ProcessQuery currentQuery;// ProcessQuery Process
  int MyIndex;// global object for ISProcess, describe the index number for current IS
  Relation theRelaiton;

  public ISProcess(MultiQueue FIFOChannel, Relation theRelation, int ISnumber){

    // keep the public FIFOchannel
    publicFIFOChannel = FIFOChannel;
    // keep the assigned IS number(used for View computation)
    MyIndex = ISnumber;

    // create SendUpdates process
    currentUpdates = new SendUpdates(FIFOChannel, ISnumber);
    // create ProcessQuery process
    currentQuery = new ProcessQuery(FIFOChannel, theRelation, ISnumber);
  }

}
