////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
//
//
// LocalCondition
//
//

/**
* LocalCondition is the condition with one Relation.
* e.g. R.A = 5, R.B > 5 or R.C < 10, etc.
*/
public class LocalCondition  implements java.io.Serializable
{
  Attribute Operand1;
  Operator Op;
  PrimitiveValue Operand2;

  public LocalCondition(Attribute attr, Operator newOp, PrimitiveValue value) throws Exception{

    if(attr == null || newOp == null || value == null)
      throw new ParaNullException("LocalCondition", "LocalCondition()", "attr, newOp, or value");

    Operand1 = attr;
    Op = newOp;
    Operand2 = value;
  }

  public String getSQL(){

    try{
      return Operand1.getSQL() + Op.getSQL() + Operand2.getSQL();
    }catch(Exception e){
      System.out.println("LocalCondition:getSQL() Error: " + e.getMessage());
      return null;
    }
  }

}

