////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
public class LogUpdates extends Thread implements java.io.Serializable{
  
  protected MultiQueue publicFIFOChannel;
  protected Queue UpdateMessageQueue;
  protected boolean finished = false;
  
  public LogUpdates(MultiQueue theFIFO, Queue theMessageQueue){
    
    super();
    publicFIFOChannel = theFIFO;
    
    UpdateMessageQueue = theMessageQueue;
    this.start();
  }
  
  public void run(){
    
    while(!finished){
      
      try{
        // Receive Delta R from Data Source i
        UpdateData theUpdate= publicFIFOChannel.receive();

        // Append (DeltaR, i) TO UpdateMessageQueue
        UpdateMessageQueue.Append(theUpdate);

        //System.out.println("LogUpdates:run() Update Logged" + theUpdate);
      }catch(Exception e){
        
        //System.out.println("LogUpdates::run: " + e.getMessage());
        
        try{
          // have a rest and try again.
          sleep(PSWEEP.PSWEEP.step);
        }catch(Exception e1){
          
          System.out.println("LogUpdates::run: I cannot sleep because " + e1.getMessage());
        }
        
      }
    }
  }
}
