////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
//
//
// Operator
//
//
public final class Operator implements java.io.Serializable
{
  final static String EQUAL = "=";
  final static String GREAT = ">";
  final static String LESS = "<";
  final static String NOTLESSTHAN = ">=";
  final static String NOTGREATETHAN = "<=";

  String Value;

  /** Initialize the Operand.
  * The Default value is EQUAL
  */
  public Operator(){

    Value = EQUAL;

  }

  public Operator(String op){
    
    this();

    if(op.equals(EQUAL) || op.equals(GREAT) 
    || op.equals(LESS) || op.equals(NOTLESSTHAN) || op.equals(NOTGREATETHAN))
      Value = op;
    else
      System.out.println("Operator: unknow operator" + op);

  }

  public String getSQL(){

    return Value;

  }
}

