////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
import java.util.Vector;

//
//
// ProjectList
//
//

// Project List will be implemented in a Vector of Attributes

public class ProjectList extends Vector implements java.io.Serializable
{
  Vector AttributeList;

  // Create a empty ProjectList
  public ProjectList(){
    AttributeList = new Vector();
  }

  // Create ProjectList from an array of Attributes
  public ProjectList(Attribute newAttrs[]){
    this();

    int size = newAttrs.length;
    for(int i = 0; i< size; i++)
      AttributeList.addElement(newAttrs[i]);
  }

  // Get a part of SQL 
  // e.g. ... SELECT R.A, S.B ..., it will return R.A , S.B
  public String getSQL(){
    int size = AttributeList.size();
    String query = new String();

    for(int i = 0; i < size -1; i++)
      query += ((Attribute)AttributeList.elementAt(i)).getSQL() + " , ";

    if(size > 0)
      query += ((Attribute)AttributeList.elementAt(size-1)).getSQL();

    return query;
  }
}

