////////////////////////////////////////////////////////////////// COPYRIGHT //
//
//  EVE 2.0 - Evolvable View Environment
//
//  Copyright 1997-2000, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty. 
//  In no event will the authors be held liable for any damages arising 
//  from the use of this software.
// 
//  Authors:
//      Andreas Koeller, Xin Zhang, Elke Rundensteiner
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/dsrg/EVE
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to the
//  EVE Development Team: <rundenst@cs.wpi.edu>.
//
////////////////////////////////////////////////////////////////// COPYRIGHT //
package SWEEP;
import java.util.*; // for Date class

// this class defines a time stamped element.
// In this class, we have attribute time, to record the time of element.
// It is useful for desiding QueryResulting and RelationUpdate which comes
// first. If an RelationUpdate stamp is newer than QueryResult time stamp,
// we think that is no concurrency. So, I have CHANGED a little bit of
// condition checking of concurrency.


public class StampedElement extends Element implements java.io.Serializable{

    /**
     * the id ( as the default timestamp) of the StampedElement. It
     * used to compare the QueryResult and DataUpdate.
     */
    static long id;
    long TimeStamp;

  public StampedElement(){

    super();
    
    id++;
    // if id overflow, we need to decrease all the objects of the
    // StampedElement, then we still got correct order.
    TimeStamp = id;

  }

  // Reset the time stamp of this element.
  public void setTimeStamp(long d){
    TimeStamp = d;
  }

  /**
   * Retrived the time stampe of this object.
   */
  public long getTimeStamp(){
    return TimeStamp;
  }

  // compare two StampedElement, if current one is older than the parameter
  // we return true; otherwise, return false;
  public boolean OlderThan(StampedElement se){
    return se.TimeStamp > TimeStamp;
  }

};

